package com.mints.goodmoney.ui.fragment

import android.Manifest
import android.annotation.SuppressLint
import android.app.Dialog
import android.content.*
import android.os.Bundle
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.widget.AdapterView
import android.widget.GridView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.DividerItemDecoration
import androidx.viewpager.widget.ViewPager
import com.component.dly.xzzq_ywsdk.YwSDK_WebActivity.Companion.open
import com.fly.scenemodule.SceneUtil
import com.mints.goodmoney.BuildConfig
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.R
import com.mints.goodmoney.ad.banner.BannerManager
import com.mints.goodmoney.ad.express.PreLoadExpressManager
import com.mints.goodmoney.ad.express.TTPreLoadCarrierExpressManager
import com.mints.goodmoney.ad.express.TTPreLoadExpressXmlyManager
import com.mints.goodmoney.ad.video.VideoAdingManager
import com.mints.goodmoney.common.AppConfig
import com.mints.goodmoney.common.Constant
import com.mints.goodmoney.manager.*
import com.mints.goodmoney.mvp.model.*
import com.mints.goodmoney.mvp.presenters.MyPresenter
import com.mints.goodmoney.mvp.views.MyView
import com.mints.goodmoney.service.AppInstallService
import com.mints.goodmoney.ui.activitys.*
import com.mints.goodmoney.ui.adapter.AdBannerAdapter
import com.mints.goodmoney.ui.adapter.GvMyAdapter
import com.mints.goodmoney.ui.adapter.MainMyAdapter
import com.mints.goodmoney.ui.adapter.ViewPagerAdapter
import com.mints.goodmoney.ui.adapter.listener.OnItemChildClickListener
import com.mints.goodmoney.ui.fragment.base.BaseFragment
import com.mints.goodmoney.ui.widgets.ShareDialog
import com.mints.goodmoney.ui.widgets.dialog.DialogListener
import com.mints.goodmoney.ui.widgets.dialog.DialogUtils
import com.mints.goodmoney.ui.widgets.seekbar.BubbleUtils
import com.mints.goodmoney.utils.*
import com.mints.library.net.netstatus.NetUtils
import com.mints.library.utils.CommonUtils
import com.mints.library.utils.GlideUtils
import com.mints.library.utils.nodoubleclick.AntiShake
import com.rd.animation.type.AnimationType
import com.scwang.smartrefresh.layout.api.RefreshLayout
import com.scwang.smartrefresh.layout.listener.OnRefreshListener
import com.tbruyelle.rxpermissions.RxPermissions
import kotlinx.android.synthetic.main.fragment_main_my.*
import kotlinx.android.synthetic.main.header_layout.*
import kotlinx.android.synthetic.main.item_fragment_main_my_clock.*
import kotlinx.android.synthetic.main.item_fragment_main_my_customer_service.*
import kotlinx.android.synthetic.main.item_fragment_main_my_promotions.*
import kotlinx.android.synthetic.main.item_fragment_main_my_title.*
import kotlinx.android.synthetic.main.view_title.*
import net.grandcentrix.tray.AppPreferences
import java.math.BigDecimal
import java.util.*
import kotlin.concurrent.schedule
import kotlin.math.ceil

private val TAG = MyFragment::class.java.simpleName

/**
 * 描述：我
 * 作者：孟崔广
 * 时间：2020/6/4 17:30
 */
@SuppressLint("SetTextI18n")
class MyFragment : BaseFragment(),
        MyView,
        OnItemChildClickListener,
        OnRefreshListener,
        View.OnClickListener,
        AdapterView.OnItemClickListener, AdBannerAdapter.OnPageClickListener {

    companion object {
        const val HOT_PAGE_SIZE = 8
    }

    private val ps by lazy { AppPreferences(context) }
    private val myPresenter by lazy { MyPresenter() }
    private val userManager by lazy { UserManager.getInstance() }
    private lateinit var videoAdingManager: VideoAdingManager
    private var loadVideoFailCount = 0

    private var userConfig: MyInfo? = null
    private val hotList: MutableList<BannerBean.ListBean> = mutableListOf()

    // 当天签到金币
    private var carrierType = ""
    private var curSignCoin = 50

    // 牧场人生安装奖励金币
    private var pkgMCRSName = ""
    private var pkgMCRSCarrier = ""
    private var pkgMCRSKey = ""

    // 签到信息
    private var signCardBean: SignCardBean? = null

    // 任务数据
    private val dataList: MutableList<MyInfo.AutoListBean> = mutableListOf()
    private var mainMyAdapter: MainMyAdapter? = null

    // Banner
    private var mAdBannerAdapter: AdBannerAdapter? = null
    private var mBannerData: RotationChartBean? = null

    // 高额任务
    private var mCurrentPkg: String? = null
    private var mReceiverBroadcastReceiver: BroadcastReceiver? = null

    // 热门活动下标
    private var mCurrentIndex = 0

    override fun getContentViewLayoutID() = R.layout.fragment_main_my

    override fun initViewsAndEvents() {
        myPresenter.attachView(this)
        srl_my.setOnRefreshListener(this)

        initManager()
        initView()
        initRecy()
    }


    override fun onHiddenChanged(hidden: Boolean) {
        if (hidden) { // 不在最前端界面显示
            onPause()
        } else { // 重新显示到最前端中
            onResume()
        }
        super.onHiddenChanged(hidden)
    }

    override fun onPause() {
        super.onPause()
        banner_view.stopAutoScroll()

        item_clock_signview.stopRedbox()
    }

    override fun onResume() {
        super.onResume()

        if (AppConfig.fragmentClickFlag == Constant.FRAGMENT_CLICK_FIVE) {
            // 防止首次加载两次
            if (AntiShake.check(item_title_id?.id)) return

            DownloadApkManager.tryOnceInstallApk()

            if (!TextUtils.isEmpty(userManager.userID)) {

                myPresenter.getAutoUserHallBaseMsg()
                refreshHighTask()
            } else {
                // 游客登录
                myPresenter.userLogin()
            }

            // 刷新喜马拉雅信息流
            TTPreLoadExpressXmlyManager.getInstance().loadTtFrameLayout()
        }
    }

    /**
     * 刷新高额任务
     */
    private fun refreshHighTask() {
        if (AppConfig.isHighTask && mCurrentPkg != null) {
            if (AppTryPlayManager.getTryPlayIsOK(mCurrentPkg!!, 30)) {
                myPresenter.setHighTaskType(Constant.CARRIER_HIGH_ACTIVITY, "1")
            } else {
                val bundle = Bundle()
                bundle.putInt(Constant.MAIN_CUR_COIN, 0)
                bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_HIGH_ACTIVITY)
                readyGo(AwardActivity::class.java, bundle)

                myPresenter.setHighTaskType(Constant.CARRIER_HIGH_ACTIVITY, "0")
            }
            AppConfig.isHighTask = false
        }
    }

    override fun onDestroyView() {
        item_clock_signview.onDestory()
        super.onDestroyView()
    }

    override fun onDestroy() {
        super.onDestroy()
        fl_my_banner?.removeAllViews()
        BxmManager.onDestory()
        BannerManager.onDestroy()
        myPresenter.detachView()

        onDestroyBroadcastReceiver()
    }

    override fun getUserTaskMsgSuc(data: MyInfo?) {

        srl_my.finishRefresh(true)

        if (data == null) {
            userConfig = null
            return
        }

        myPresenter.getSignInHomePageMsg()
        myPresenter.myHotActivity()
        myPresenter.getHallBaseMsg()
        myPresenter.myRotationChart()

        userConfig = data
        handleRecyData()
        setUserLoginStatus()
    }

    override fun getUserTaskMsgFail() {

        srl_my.finishRefresh(false)
        userConfig = null
        vp_grid.visibility = View.GONE
        setUserLoginStatus()
    }

    override fun getMyHotActivitySuc(data: BannerBean?) {

        if (activity != null && !requireActivity().isFinishing) {
            data?.let {
                vp_grid.visibility = View.VISIBLE
                hotList.clear()
                hotList.addAll(it.list)
                generateGridData(hotList)
            }
        }
    }

    // 生成热门活动数据
    private fun generateGridData(data: List<BannerBean.ListBean>) {
        val inflater = LayoutInflater.from(mContext)
        for (i in 0..data.size - 1) {
            if (data.get(i).toUrl.equals(Constant.HOT_ACTIVITY_SHEEP)) {
                XmManager.loadMater(data.get(i).xmPlaceId)
                LogUtil.d("clickOnLinster", "--------------------------剪羊毛曝光入口！")
                break
            }
        }
        val pageCount = ceil(data.size * 1.0 / HOT_PAGE_SIZE).toInt()
        val pagerList = arrayListOf<View>()

        for (i in 0 until pageCount) {

            val gridView = inflater.inflate(R.layout.item_fragment_main_my_promotions_gv,
                    vp_grid, false) as GridView
            gridView.adapter = GvMyAdapter(requireActivity(), data, i, HOT_PAGE_SIZE)
            pagerList.add(gridView)

            gridView.onItemClickListener = this
        }

        if (pageCount <= 1) {
            piv_grid.visibility = View.GONE
        } else {
            piv_grid.visibility = View.VISIBLE
            piv_grid.count = pageCount
        }

        mCurrentIndex = 0

        piv_grid.count = pageCount
        piv_grid.setAnimationType(AnimationType.THIN_WORM)
        vp_grid.adapter = ViewPagerAdapter(pagerList)
//        vp_grid.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
//            override fun onPageScrollStateChanged(state: Int) {
//            }
//
//            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {
//            }
//
//            override fun onPageSelected(position: Int) {
//                mCurrentIndex = position
//
//                piv_grid.selection = position
//            }
//
//        })
    }

    override fun getSignInHomePageMsgSuc(signBean: SignCardBean?) {
        if (signBean == null) {
            signCardBean = null
            return
        }

        signCardBean = signBean
        // 初始化签到
        setSignDayLayout(signCardBean!!)
    }

    override fun signInHomePageSuc() {
        val bundle = Bundle()
        bundle.putInt(Constant.MAIN_CUR_COIN, curSignCoin)
        bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_SIGNIN_HOMEPAGE_AWARD)
        readyGo(AwardActivity::class.java, bundle)
    }

    //游客登陆成功
    override fun userLoginSuc() {
        SceneManager.signIn(requireActivity())

        myPresenter.getAutoUserHallBaseMsg()
        myPresenter.getHallBaseMsg()
    }

    override fun getHallBaseMsgSuc(data: UserTaskMsgBean) {
        if (requireActivity().isFinishing) {
            return
        }

        // 高额任务及超级翻倍次数
        if (data.highRatePlan != null) {
            AppConfig.csjHighVideoAdCount = data.highRatePlan.csj
            AppConfig.ylhHighVideoAdCount = data.highRatePlan.ylh
            AppConfig.ksHighVideoAdCount = data.highRatePlan.ks
        }

        if (data.shareNews != null) {
            AppConfig.wzReadCoin = data.shareNews.readCoin
        }

        // 设置视频权重
        UserWeight.initAdWeight(data)
        initExpress(data.flowAdRules)
        AppConfig.app_black_name = data.userRiskApps.userRiskAppName
        AppConfig.app_black_pkg = data.userRiskApps.userRiskAppPkg
        AppConfig.flVideoFlag = data.vedioRules.isFlVideoFlag
        AppConfig.user_register_channel = data.channel
        if (data.adcode != null) {
            AppConfig.user_channel_ad = data.adcode.key
        }
        ChannelManager.updataCodeIdForRegisterChannel(data.adcode)

        // 是否上报点击广告
        AppConfig.needReportClickAdEvent = data.isNeedReportClickAdEvent

        // 新人福利
        if (data.userMsg.firstGiveCoin > 0) {
            val bundle = Bundle()
            bundle.putInt(Constant.MAIN_CUR_COIN, data.userMsg.firstGiveCoin)
            bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_NEW_USER)
            readyGo(AwardActivity::class.java, bundle)
        } else {
            // 离线收益
            if (data.offlineBean.offlineIncome > 0) {
                val bundle = Bundle()
                bundle.putInt(Constant.MAIN_CUR_COIN, data.offlineBean.offlineIncome)
                bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_OFFLINE_DOUBLE)
                readyGo(AwardActivity::class.java, bundle)
            }
        }
    }

    private fun gzhDialog() {
        DialogUtils.showGzhDialog(requireActivity(), object : DialogListener() {
            override fun onClick(dialog: Dialog?, v: View?) {
                when (v?.id) {
                    R.id.tv_focus -> {
                        //并将“淘金空间”复制到粘贴板上
//                        val clipboardManager = dialog?.ownerActivity?.getSystemService(Context.CLIPBOARD_SERVICE) as ClipboardManager
//                        val clipData = ClipData.newPlainText("Label", "淘金空间")
//                        clipboardManager.setPrimaryClip(clipData)
//                        // Toast 提示
//                        showToast("已复制内容到剪贴板")
                        //直接跳转到微信搜索界面
                        getWechatApi()
                    }
                    R.id.tv_subscribe -> {
                        //关闭当前页面
                        //并不在提示当前弹窗
                        if (activity != null && !activity!!.isFinishing && dialog != null && dialog.isShowing) {
                            dialog.dismiss()
                            ps.put(Constant.LOAN_PERMISSION_FLAG, false)
                            // 数美初始化
                            ShumeiManager.getInstance().initShumei()
                        }
                    }
                    R.id.iv_Close -> {
                        //关闭当前界面
                        //再次打开时会继续弹出该弹窗
                        if (activity != null && !activity!!.isFinishing && dialog != null && dialog.isShowing) {
                            dialog.dismiss()
                            ps.put(Constant.LOAN_PERMISSION_FLAG, false)
                            // 数美初始化
                            ShumeiManager.getInstance().initShumei()
                        }
                    }
                }

            }
        })
    }

    /**
     * 跳转到微信搜索页面
     */
    private fun getWechatApi() {
        LogUtil.d("getWeChatApi","点击事件响应了。。。。。。。。。。。。。。。。。。。")
        try {
            val intent = Intent(Intent.ACTION_MAIN)
            val cmp = ComponentName("com.tencent.mm", "com.tencent.mm.ui.LauncherUI")
            intent.addCategory(Intent.CATEGORY_LAUNCHER)
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            intent.component = cmp
            startActivity(intent)
        } catch (e: ActivityNotFoundException) {
            showToast("检查到您手机没有安装微信，请安装后使用该功能")
        }
    }

    /**
     * 设置Banner
     */
    override fun getMyRotationChartSuc(data: RotationChartBean) {
        mBannerData = data

        if (mBannerData?.list == null || mBannerData?.list!!.size == 0) {
            mAdBannerAdapter = null

            fl_my_banner.visibility = View.VISIBLE
            LogUtil.d("TAG", "getMyRotationChartSuc")
            banner_view.visibility = View.GONE
            banner_view.stopAutoScroll()
            BannerManager.getTtBanner(TtCsjAdManager.TT_AD_BANNER_MY, fl_my_banner)
        } else {

            fl_my_banner.visibility = View.GONE
            banner_view.visibility = View.VISIBLE
            mAdBannerAdapter = AdBannerAdapter(activity)

            mAdBannerAdapter?.let {
                val list: MutableList<RotationChartBean.ListBean?> = mutableListOf()
                list.addAll(mBannerData?.list!!)
                list.add(data.position, null)
                it.setOnPageClickListener(this)
                it.setData(list)
                it.setAdPosition(data.position)
                banner_view.setAdapter(it)
            }
            banner_view.startAutoScroll()
        }
    }

    override fun onRefresh(refreshLayout: RefreshLayout) {
        onDestroyBroadcastReceiver()

        if (userManager.userID.isNotEmpty()) {
            myPresenter.getAutoUserHallBaseMsg()
        } else {
            myPresenter.userLogin()
        }

    }

    /**
     * 设置签到样式
     *
     * @param signCardBean
     */
    private fun setSignDayLayout(signCardBean: SignCardBean) {
        ll_my_sign.visibility = View.VISIBLE
        val nowDate = signCardBean.nowDate
        var signStatus = 0 //0-未签到 1-已签到 2-已签到且看了视频
        val signList = signCardBean.list
        if (signList != null && signList.size > 0) {
            val signGoldList = ArrayList<Int>()
            val signViewBean = SignViewBean()
            for (i in signList.indices) {
                val signBean = signList[i]
                val signDays = signBean.d
                // 初始化每天的金币
                when (signDays) {
                    1 -> {
                        signGoldList.add(signBean.coin)
                        signViewBean.firstStatus = signBean.status
                    }
                    2 -> {
                        signGoldList.add(signBean.coin)
                        signViewBean.twoStatus = signBean.status
                    }
                    3 -> {
                        signGoldList.add(signBean.coin)
                        signViewBean.threeStatus = signBean.status
                    }
                    4 -> {
                        signGoldList.add(signBean.coin)
                        signViewBean.fourStatus = signBean.status
                    }
                    5 -> {
                        signGoldList.add(signBean.coin)
                        signViewBean.fiveStatus = signBean.status
                    }
                    6 -> {
                        signGoldList.add(signBean.coin)
                        signViewBean.sixStatus = signBean.status
                    }
                    7 -> {
                        signGoldList.add(signBean.coin)
                        signViewBean.sevenStatus = signBean.status
                    }
                }

                // 获取当天状态
                if (nowDate == signDays) {
                    signStatus = signBean.status
                    curSignCoin = signBean.coin
                }
            }

            // 初始化金币数据
            item_clock_signview.initSignViewGoldLayout(signGoldList)
            // 设置签到样式
            item_clock_signview.setSignViewLayout(signViewBean)
            // 重新设置当天签到样式
            item_clock_signview.setCurDaysSignViewLayout(nowDate, signStatus)
            if (signStatus == 0) {
                myPresenter.signInHomePage()
            }
        }

        // 根据当天状态 计算连续签到天数
        val alwaysSignDay = if (signStatus == 0) {
            nowDate - 1
        } else {
            nowDate
        }
        item_clock_signday.text = SpanUtils()
                .append("  已连续签到").setForegroundColor(ContextCompat.getColor(mContext, R.color.color_172B54))
                .append(" $alwaysSignDay ").setForegroundColor(ContextCompat.getColor(mContext, R.color.color_F18542))
                .append("天").setForegroundColor(ContextCompat.getColor(mContext, R.color.color_172B54))
                .create()
        val finalSignStatus = signStatus
        item_clock_signview.setSignViewListener { day ->
            if (nowDate == day) {
                if (finalSignStatus == 1) {
                    carrierType = Constant.CARRIER_SIGNIN_HOMEPAGE_CARD
                    awardVideo(curSignCoin * 2, Constant.CARRIER_SIGNIN_HOMEPAGE_CARD)
                }
            }
        }
    }

    private fun setUserLoginStatus() {
        if (userManager.userIsLogin()) {
            LogUtil.d("lixianshouyi","setUserLoginStatus。。。。。。。。。。。。。。。。。。。。。。。。。。")
            // 已登录
            if (userManager.wxOpenid.isNotEmpty()) {
                GlideUtils.loadImageViewLoding(context, userManager.wxHeader, item_title_avatar, R.mipmap.ic_my, R.mipmap.ic_my)
                if (userManager.wxName.isEmpty()) {
                    var mobile = userManager.mobile
                    if (mobile.isNotEmpty()) {
                        mobile = mobile.substring(0, 3) + "****" + mobile.substring(mobile.length - 4, mobile.length)
                    }
                    item_title_id.text = "手机:$mobile"
                } else {
                    item_title_id.text = userManager.wxName
                }
            } else {
                var mobile = userManager.mobile
                if (mobile.isNotEmpty()) {
                    mobile = mobile.substring(0, 3) + "****" + mobile.substring(mobile.length - 4, mobile.length)
                }
                item_title_id.text = "手机:$mobile"
                item_title_avatar.setImageResource(R.mipmap.ic_my)
            }
        } else {
            // 未登录
            var userId = userManager.userID
            if (userId.isNotEmpty() && userId.length > 11) {
                userId = userId.substring(userId.length - 10)
                item_title_id.text = "游客$userId 去登录"
            } else {
                item_title_id.text = "游客 去登录"
            }
            item_title_avatar.setImageResource(R.mipmap.ic_my)
        }

        if (BuildConfig.DEBUG) {
            item_title_id.text = "-${item_title_id.text}"
        }

        var userGold = "0.00"
        if (userConfig != null) {

            val allcoinBig = BigDecimal(userConfig!!.userMsg.coin.toString())
            val rateBig = BigDecimal("10000")
            val cashStr: String = allcoinBig.divide(rateBig).setScale(2, BigDecimal.ROUND_DOWN).toString()
            item_title_gold_about.text = "约" + cashStr + "元"

            userGold = CommonUtils.formatString(userConfig!!.userMsg.coin.toString())
            userManager.usercash = userConfig!!.userMsg.coin.toString()
        }
        item_title_gold_count.text = userGold
    }

    /**
     * 处理列表数据
     */
    private fun handleRecyData() {
        userConfig?.let {
            item_bottom_qqGroupNum.text = userConfig?.qqMsg?.useqq?.name + "：" + userConfig?.qqMsg?.useqq?.qq
        }

        dataList.clear()
        dataList.addAll(userConfig!!.autoList)
        mainMyAdapter?.notifyDataSetChanged()
    }

    // 每日任务
    override fun onItemChildClick(view: View?, position: Int) {
        if (AntiShake.check(view?.id)) return

        if (!NetUtils.isNetworkConnected(context)) {
            showToast("网络异常,请检测网络")
            return
        }

        when (view?.id) {
            R.id.item_task_click -> {
                val taskBean = dataList[position]
                when (taskBean.baseConfig.taskId) {
                    // 跳转珊瑚CPD下载试玩任务
                    MainMyAdapter.TO_CPD -> {
                        if (!UserManager.getInstance().userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }

                        carrierType = ""

                        readyGo(TaskCpdActivity::class.java)
                    }
                    // 跳转高额视频
                    MainMyAdapter.APP_HiGH_ACTIVITY -> {
                        if (!UserManager.getInstance().userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }

                        if (taskBean.otherConfig != null) {
                            if (taskBean.otherConfig.complete >= taskBean.otherConfig.max) {
                                showToast("看高额视频赚金币任务已完成，请明日再来")
                                return
                            }

                            when (taskBean.otherConfig.status) {
                                // 0-去下载  1-去领取 3-去试玩
                                0 -> {
                                    if (AppUtil.isOpenUsageStats()) {
                                        highVideoTint(taskBean)
                                    } else {
                                        openAppUsageStats()
                                    }
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_HIGH_ACTIVITY)
                                    readyGo(AwardActivity::class.java, bundle)

                                    AppConfig.isHighTask = false
                                    mCurrentPkg = null
//                                    ps.remove(Constant.HIGH_TASK_PKG_NAME)
                                }
                                3 -> {
//                                    if (mCurrentPkg == null) {
//                                        // 如果当前包名为空，获取本地存储的包名
//                                        mCurrentPkg = ps.getString(Constant.HIGH_TASK_PKG_NAME, "")
//                                    }
//                                    if (TextUtils.isEmpty(mCurrentPkg)) {
                                    if (mCurrentPkg == null) {
                                        showToast("任务异常，请重试~")
                                        myPresenter.setHighTaskType(Constant.CARRIER_HIGH_ACTIVITY, "0")

                                        AppConfig.isHighTask = false
                                    } else {
                                        if (AppUtil.checkPackInfo(mContext, mCurrentPkg!!)) {
                                            AppTryPlayManager.toTryPlay(mCurrentPkg!!)

                                            AppConfig.isHighTask = true
                                        } else {
                                            showToast("未找到当前APP、可能被卸载，请重试~")
                                            myPresenter.setHighTaskType(Constant.CARRIER_HIGH_ACTIVITY, "0")

                                            AppConfig.isHighTask = false
                                        }
                                    }
                                }
                            }
                        }
                    }
                    // 跳转分享文章
                    MainMyAdapter.TO_SHARE_NEWS -> {
                        if (!UserManager.getInstance().userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }

                        when (taskBean.otherConfig.status) {
                            0, 2 -> {
                                // 去分享文章
                                shareArticle(taskBean.otherConfig.readCoin)
                            }
                            1 -> {
                                val bundle = Bundle()
                                bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_SHARE_NEWS)
                                readyGo(AwardActivity::class.java, bundle)
                            }
                        }
                    }
                    // 跳转首页视频
                    MainMyAdapter.TO_HOME -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0, 2 -> {
                                    val activity: MainActivity? = activity as MainActivity?
                                    activity?.let {
                                        it.clickTab1Layout()
                                        it.selectVedio()
                                    }
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_HOMEVEDIO_CHALLENGE)
                                    readyGo(AwardActivity::class.java, bundle)
                                }
                            }
                        }
                    }
                    // 跳转短视频
                    MainMyAdapter.TO_MINI_VEDIO -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0, 2 -> {
                                    val activity: MainActivity? = activity as MainActivity?
                                    activity?.clickTab2Layout()
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_MINIVEDIO_CHALLENGE)
                                    readyGo(AwardActivity::class.java, bundle)
                                }
                            }
                        }
                    }
                    // 邀好友赚金币
                    MainMyAdapter.APP_SHAREFRIEND -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0, 2 -> {
                                    // 邀请好友
                                    if (!UserManager.getInstance().userIsLogin()) {
                                        readyGo(WxLoginActivity::class.java)
                                        return
                                    }

                                    if (!ps.getBoolean(Constant.FIRST_SHARE_MY, false)) {
                                        // 第一次邀请提示弹框
                                        firstWeChatInvite()
                                    } else {
                                        shareImgDialog()
                                    }
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CHALLENGE_SHAREFRIEND)
                                    bundle.putString(Constant.MAIN_EXTRA_ID, taskBean.otherConfig.doubleCoin.toString())
                                    readyGo(AwardActivity::class.java, bundle)
                                }
                            }
                        }
                    }
                    // 看福利视频赚金币
                    MainMyAdapter.APP_VEDIO -> {
                        if (taskBean.otherConfig != null) {
                            if (taskBean.otherConfig.complete >= taskBean.otherConfig.max) {
                                showToast("看福利视频赚金币任务已完成，请明日再来")
                                return
                            }

                            awardVideo(taskBean.otherConfig.coin, Constant.CARRIER_VERSUS_VIDEO)
                        }

                    }
                    // 玩游戏，赚金币
                    MainMyAdapter.TO_LIEBAO -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0, 2 -> {
                                    readyGo(LiebaoGameActivity::class.java)
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_GAME_ONLINE)
                                    readyGo(AwardActivity::class.java, bundle)
                                }
                            }
                        }
                    }
                    // 新闻
                    MainMyAdapter.TO_RUISHI -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0, 2 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.WRAPPER_TYPE, Constant.WRAPPER_TYPE_NEWS)
                                    readyGo(WrapperActivity::class.java, bundle)
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_RUISHINEWS_CHALLANGE)
                                    readyGo(AwardActivity::class.java, bundle)
                                }
                            }
                        }
                    }
                    // 小说
                    MainMyAdapter.TO_ZHANGYUE -> {
                        val activity: MainActivity? = activity as MainActivity?
                        activity?.let {
                            it.clickTab1Layout()
                            it.selectBook()
                        }
                    }
                    // 试玩平台
                    MainMyAdapter.TO_YWHZ -> {
                        if (!userManager.userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }

                        try {
                            activity?.let { open(it) }
                        } catch (e: Exception) {
                            e.printStackTrace()
                            showToast("请重新退出账号登录")
                        }
                    }
                    MainMyAdapter.TO_DHGAME -> {
                        if (!UserManager.getInstance().userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }

                        readyGo(DhGameActivity::class.java)
                    }
                    MainMyAdapter.TO_XMLY -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0, 2 -> {
                                    val activity: MainActivity? = activity as MainActivity?
                                    activity?.let {
                                        it.clickTab1Layout()
                                        it.selectXmly()
                                    }
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_XMLY_CHALLENGE)
                                    readyGo(AwardActivity::class.java, bundle)
                                }
                            }
                        }
                    }
                    MainMyAdapter.TO_FIRSTDOWNLOAD -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0 -> {
                                    // 牧场人生包名
                                    pkgMCRSCarrier = Constant.CARRIER_MC_FIRSTDOWNLOAD
                                    pkgMCRSKey = ""
                                    pkgMCRSName = taskBean.otherConfig.pkg

                                    // 下载牧场人生
                                    DownloadApkManager.downloadApk(requireActivity(), taskBean.otherConfig.downloadUrl, pkgMCRSName)

                                    // 开启广播监听安装事件
                                    registerBroad()
                                }
                                1 -> {
                                    // 牧场人生APP，直接弹奖励框
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_MC_FIRSTDOWNLOAD)
                                    readyGo(AwardActivity::class.java, bundle)

                                    onDestroyBroadcastReceiver()
                                }
                            }
                        }
                    }
                    MainMyAdapter.TO_DOWNLOADS -> {
                        if (taskBean.otherConfig != null) {
                            when (taskBean.otherConfig.status) {
                                0 -> {
                                    pkgMCRSCarrier = Constant.CARRIER_FIRSTDOWNLOADS
                                    pkgMCRSKey = taskBean.otherConfig.key
                                    pkgMCRSName = taskBean.otherConfig.pkg
                                    DownloadApkManager.downloadApk(requireActivity(), taskBean.otherConfig.downloadUrl, pkgMCRSName)
                                    // 开启广播监听安装事件
                                    registerBroad()
                                }
                                1 -> {
                                    val bundle = Bundle()
                                    bundle.putInt(Constant.MAIN_CUR_COIN, taskBean.otherConfig.coin)
                                    bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_FIRSTDOWNLOADS)
                                    bundle.putString(Constant.MAIN_EXTRA_ID, taskBean.otherConfig.key)
                                    readyGo(AwardActivity::class.java, bundle)

                                    onDestroyBroadcastReceiver()
                                }
                            }
                        }
                    }
                    MainMyAdapter.TO_MOKU -> {
                        gotoMoku()
                    }
                    MainMyAdapter.TO_YYZ -> {
                        // 愉悦赚事件
                        if (!userManager.userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }
                        YyzManager.openYyzTask(requireActivity())
                    }
                }
            }
        }
    }

    //点击事件
    override fun onClick(v: View?) {
        if (AntiShake.check(view?.id)) return

        if (!NetUtils.isNetworkConnected(context)) {
            showToast("网络异常,请检测网络")
            return
        }

        when (v?.id) {
            R.id.ll_my_login -> {
                if (!userManager.userIsLogin()) {
                    readyGo(WxLoginActivity::class.java)
                }
            }
            R.id.tv_left_subtitle -> {
                val bundle = Bundle()
                bundle.putString(WebActivity.WEB_TITLE, getString(R.string.strategy_name))
                bundle.putString(WebActivity.WEB_URL, Constant.STRATEGY_URL)
                readyGo(WebActivity::class.java, bundle)
            }
            R.id.iv_right_icon2 -> {
                // 跳转QQ客服
                jumpQQGroup()
            }
            R.id.item_customer_service -> {
                // 跳转加入QQ群
                jumpQQGroup()
            }
            R.id.item_title_id -> {
                if (!userManager.userIsLogin()) {
                    readyGo(WxLoginActivity::class.java)
                }
            }
            R.id.iv_right_icon -> {
                readyGo(SettingsActivity::class.java)
            }
            R.id.btn_withdraw -> {
                if (userConfig == null) {
                    showToast("网络异常,请检测网络！")
                    myPresenter.getAutoUserHallBaseMsg()
                    return
                }

                readyGo(DrawcashActivity::class.java)
            }
            R.id.btn_coinRecord -> {
                if (userConfig == null) {
                    showToast("网络异常,请检测网络！")
                    myPresenter.getAutoUserHallBaseMsg()
                    return
                }
                readyGo(CoinRecordActivity::class.java)
            }
            R.id.item_title_friends -> {
                val bundle = Bundle()
                bundle.putInt(Constant.WRAPPER_TYPE, Constant.WRAPPER_TYPE_FRIENDS)
                readyGo(WrapperActivity::class.java, bundle)
            }
        }
    }

    // 热门活动
    override fun onItemClick(parent: AdapterView<*>, view: View, position: Int, id: Long) {
        if (hotList.isNotEmpty()) {
            val hotBean: BannerBean.ListBean = hotList[position + (mCurrentIndex * HOT_PAGE_SIZE)]

            if (!TextUtils.isEmpty(hotBean.toUrl)) {
                // 自有界面
                when (hotBean.toUrl) {
                    //小满剪羊毛
                    Constant.HOT_ACTIVITY_SHEEP -> {
                        XmManager.exprotClick(hotBean.xmPlaceId)
                        val bundle = Bundle()
                        bundle.putString(Constant.ACTIVITY_TITLE, hotBean.title)
                        bundle.putString(Constant.ACTIVITY_ID, hotBean.xmPlaceId)
                        readyGo(XiaomanActivity::class.java, bundle)
                    }
                    Constant.HOT_ACTIVITY_WATER -> {
                        TTPreLoadCarrierExpressManager.getInstance().loadTtFrameLayout(TtCsjAdManager.TT_AD_NATIVEEXPRESS_WATER)
                        readyGo(WaterActivity::class.java)
                    }
                    Constant.HOT_ACTIVITY_WALK -> {
                        TTPreLoadCarrierExpressManager.getInstance().loadTtFrameLayout(TtCsjAdManager.TT_AD_NATIVEEXPRESS_WALK)
                        readyGo(WalkActivity::class.java)
                    }
                    Constant.HOT_ACTIVITY_CARD -> {
                        readyGo(EraseActivity::class.java)
                    }
                    Constant.HOT_ACTIVITY_LIEBAO -> {
                        readyGo(LiebaoGameActivity::class.java)
                    }
                    Constant.HOT_ACTIVITY_MORNINGCLOCK -> {
                        TTPreLoadCarrierExpressManager.getInstance().loadTtFrameLayout(TtCsjAdManager.TT_AD_NATIVEEXPRESS_MORNINGCLOCK)
                        readyGo(MorningClockActivity::class.java)
                    }
                    Constant.HOT_ACTIVITY_BXM -> {
                        // 消费变现猫事件
                        if (!userManager.userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }
                    }
                    Constant.HOT_ACTIVITY_YYZ -> {
                        // 愉悦赚事件
                        if (!userManager.userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }
                        YyzManager.openYyzTask(requireActivity())
                    }
                    Constant.HOT_ACTIVITY_CAICY -> {
                        RxPermissions(requireActivity())
                                .request(Manifest.permission.READ_PHONE_STATE)
                                .subscribe { granted: Boolean ->
                                    if (granted) {
                                        if (AppConfig.scene_flag) {
                                            // 猜成语
                                            SceneUtil.cCy(requireActivity())
                                            AppConfig.scene_idiom_flag = true
                                        } else {
                                            SceneManager.signIn(requireActivity())
                                        }
                                    } else {
                                        showMissingPermissionDialog("设备")
                                    }
                                }
                    }
                    Constant.HOT_ACTIVITY_DATI -> {
                        RxPermissions(requireActivity())
                                .request(Manifest.permission.READ_PHONE_STATE)
                                .subscribe { granted: Boolean ->
                                    if (granted) {
                                        if (AppConfig.scene_flag) {
                                            // 答题
                                            SceneUtil.daTi(requireActivity())
                                        } else {
                                            SceneManager.signIn(requireActivity())
                                        }
                                    } else {
                                        showMissingPermissionDialog("设备")
                                    }
                                }
                    }
                    Constant.HOT_ACTIVITY_SCRAPPAGE -> {
                        RxPermissions(requireActivity())
                                .request(Manifest.permission.READ_PHONE_STATE)
                                .subscribe { granted: Boolean ->
                                    if (granted) {
                                        if (AppConfig.scene_flag) {
                                            // 刮刮乐
                                            SceneUtil.scrapPage(requireActivity())
                                        } else {
                                            SceneManager.signIn(requireActivity())
                                        }
                                    } else {
                                        showMissingPermissionDialog("设备")
                                    }
                                }
                    }
                    Constant.HOT_ACTIVITY_BOOK -> {
                        // 小说
                        val bundle = Bundle()
                        bundle.putInt(Constant.WRAPPER_TYPE, Constant.WRAPPER_TYPE_BOOK)
                        readyGo(WrapperActivity::class.java, bundle)
                    }
                    Constant.HOT_ACTIVITY_NEWS -> {
                        // 新闻
                        val bundle = Bundle()
                        bundle.putInt(Constant.WRAPPER_TYPE, Constant.WRAPPER_TYPE_NEWS)
                        readyGo(WrapperActivity::class.java, bundle)
                    }
                    Constant.HOT_ACTIVITY_EAT -> {
                        TTPreLoadCarrierExpressManager.getInstance().loadTtFrameLayout(TtCsjAdManager.TT_AD_NATIVEEXPRESS_EAT)
                        readyGo(FoodSubsidyActivity::class.java)
                    }
                    Constant.HOT_ACTIVITY_SHARE_NEWS -> {
                        if (!userManager.userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }

                        if (dataList.isNotEmpty()) {
                            for (listBean in dataList) {
                                if (listBean.baseConfig.taskId == MainMyAdapter.TO_SHARE_NEWS) {
                                    shareArticle(listBean.otherConfig.readCoin)
                                    return
                                }
                            }
                        }
                        shareArticle(300)
                    }
                    Constant.HOT_ACTIVITY_CPD -> {
                        if (!UserManager.getInstance().userIsLogin()) {
                            readyGo(WxLoginActivity::class.java)
                            return
                        }

                        carrierType = ""

                        if (dataList.isNotEmpty()) {
                            for (listBean in dataList) {
                                if (listBean.baseConfig.taskId == MainMyAdapter.TO_SHARE_NEWS) {
                                    readyGo(TaskCpdActivity::class.java)
                                    return
                                }
                            }
                        }
                    }
                    Constant.HOT_ACTIVITY_CALLSHOW -> {
                        val bundle = Bundle()
                        bundle.putInt(Constant.WRAPPER_TYPE, Constant.WRAPPER_TYPE_KYL)
                        readyGo(WrapperActivity::class.java, bundle)
                    }
                    Constant.HOT_ACTIVITY_MOKU -> {
                        gotoMoku()
                    }
                    else -> {
                        if (!TextUtils.isEmpty(hotBean.url) && !TextUtils.isEmpty(hotBean.title)) {
                            val bundle = Bundle()
                            bundle.putString(WebActivity.WEB_TITLE, hotBean.title)
                            bundle.putString(WebActivity.WEB_URL, hotBean.url)
                            readyGo(WebActivity::class.java, bundle)
                        }
                    }
                }
            }
        }
    }

    /**
     * 获取激励视频
     */
    private fun awardVideo(coin: Int, carrierType: String) {
        if (AppConfig.isVideoSleep) {
            showToast("加载失败，请稍后重试。")
            return
        } else if (videoAdingManager.videoFinishFlag) {
            showToast("今日视频已看完，请明天再来吧")
            return
        }

        loadVideoFailCount = 0
        showLoading("加载中...")

        val bean = VideoAdingBean()
        bean.carrierType = carrierType
        bean.curCoin = coin

        loadVideo(videoAdingManager, bean, true)
    }

    /**
     * 加载激励视频
     */
    private fun loadVideo(videoAdingManager: VideoAdingManager, bean: VideoAdingBean, isFirstLoad: Boolean) {
        videoAdingManager.setVideoAdingListener(object : VideoAdingManager.VideoAdingListener {
            override fun videoAdingListenerError(adType: String) {
                showToast("加载超时，请休息一下")
                hideLoading()
            }

            override fun videoAdingListenerFail(adType: String) {
                loadVideoFailCount++
                if (loadVideoFailCount >= 3) {
                    hideLoading()
                    showToast("加载失败，请稍后重试!")
                } else {
                    loadVideo(videoAdingManager, bean, false)
                }
            }

            override fun videoAdingListenerSuccess(adType: String) {
                hideLoading()
                videoAdingSuccess(adType)
            }
        })
        if (isFirstLoad) {
            // 首页按权重加载
            videoAdingManager.loadAding(activity, bean)
        } else {
            // 失败按优先级加载
            videoAdingManager.loadFailAding(activity, bean)
        }
    }

    /**
     * 激励视频播放成功回调
     */
    private fun videoAdingSuccess(adType: String) {
        if (activity != null && !activity!!.isFinishing) {
            // 高额任务
            if (TextUtils.equals(carrierType, Constant.CARRIER_HIGH_ACTIVITY)) {
                return
            }

            // 签到
            val bundle = Bundle()
            if (TextUtils.equals(carrierType, Constant.CARRIER_SIGNIN_HOMEPAGE_CARD)) {
                bundle.putInt(Constant.MAIN_CUR_COIN, curSignCoin * 2)
                bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_SIGNIN_HOMEPAGE_CARD)
                readyGo(AwardActivity::class.java, bundle)
                return
            }

            // 每日福利视频
            userConfig?.let {
                for (autoListBean in it.autoList) {
                    if (autoListBean.baseConfig.taskId == MainMyAdapter.APP_VEDIO) {
                        if (autoListBean.otherConfig != null) {
                            bundle.putInt(Constant.MAIN_CUR_COIN, autoListBean.otherConfig.coin)
                            bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_VERSUS_VIDEO)
                            readyGo(AwardActivity::class.java, bundle)
                            return
                        }
                    }
                }
            }
        }
    }

    private fun initManager() {
        BannerManager.init()
        videoAdingManager = VideoAdingManager.getInstance(activity)
        LogUtil.d("lixianshouyi","进入到initManager。。。。。。。。。。。。。。。。。。。。。。。。。。")
        //登录成功
        if (!TextUtils.isEmpty(userManager.userID)) {
            LogUtil.d("lixianshouyi","用户登陆成功！！！。。。。。。。。。。。。。。。。。。。。。。。。。。")
            // 登录成功的用户初始化鱼丸盒子
            if (userManager.userIsLogin()) {
                YwhzManager.init(baseApplication)
            }
        }

        // 聚乐云初始化
        SceneManager.initScene()
        SceneManager.signIn(requireActivity())

        if (!TextUtils.isEmpty(MintsApplication.OAID)) {
            MokuManager.initOaid(MintsApplication.OAID)
        }

    }

    private fun initView() {
        tv_title.text = "个人中心"
        view_title.text = "每日任务"
        iv_right_icon.visibility = View.VISIBLE
        iv_right_icon.setImageResource(R.mipmap.ic_settings)
        iv_right_icon2.visibility = View.VISIBLE
        iv_right_icon2.setImageResource(R.mipmap.icon_customer_service)
        tv_left_subtitle.visibility = View.VISIBLE
        tv_left_subtitle.text = "平台攻略"

        tv_left_subtitle.setOnClickListener(this)
        iv_right_icon2.setOnClickListener(this)
        item_title_id.setOnClickListener(this)
        iv_right_icon.setOnClickListener(this)
        btn_withdraw.setOnClickListener(this)
        btn_coinRecord.setOnClickListener(this)
        item_title_friends.setOnClickListener(this)
        ll_my_login.setOnClickListener(this)
        item_customer_service.setOnClickListener(this)

//        item_promotions_egv.onItemClickListener = this

        vp_grid.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageScrollStateChanged(state: Int) {
            }

            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {
            }

            override fun onPageSelected(position: Int) {
                mCurrentIndex = position

                piv_grid.selection = position
            }

        })
    }

    /**
     * 初始化Recyclerview
     */
    private fun initRecy() {
        recy_my.addItemDecoration(DividerItemDecoration(mContext, DividerItemDecoration.VERTICAL))
        recy_my.setItemViewCacheSize(10)
        mainMyAdapter = MainMyAdapter(mContext, dataList)
        recy_my.adapter = mainMyAdapter
        mainMyAdapter?.setOnItemChildClickListener(this)
    }

    private fun initExpress(flowAdRules: FlowAdRulesBean) {
        PreLoadExpressManager.init(flowAdRules.csj, flowAdRules.ylh, flowAdRules.ks)
    }

    /**
     * 跳转QQ群弹框
     */
    private fun jumpQQGroup() {
        DialogUtils.showDialog(mContext, "提示", "好赚钱想要打开QQ", "取消", "打开", object : DialogListener() {
            override fun onClick(dialog: Dialog?, v: View?) {
                dialog?.dismiss()

                when (v?.id) {
                    R.id.dialog_btn_right -> {
                        userConfig?.let {
                            QQJumpUtil.jumpQQGroup(it.qqMsg.useqq.url, requireActivity())
                        }
                    }
                }
            }
        })
    }

    /**
     * 第一次微信分享弹框
     */
    private fun firstWeChatInvite() {
        DialogUtils.showDialog(mContext, "提示", "被邀请人成功提现0.5元后发放贡献", "取消", "打开微信", object : DialogListener() {
            override fun onClick(dialog: Dialog?, v: View?) {
                dialog?.dismiss()

                when (v?.id) {
                    R.id.dialog_btn_right -> {
                        ps.put(Constant.FIRST_SHARE_MY, true)
                        shareImgDialog()
                    }
                }
            }
        })
    }

    /**
     * 图片分享
     */
    private fun shareImgDialog() {
        val shareDialog = ShareDialog(requireActivity())
        shareDialog.setOnShareOKListener(object : ShareDialog.OnShareOKListener {
            override fun onShareOk() {
                myPresenter.cmtShareStatus()
            }
        })
        val userManager = UserManager.getInstance()
        val title: String
        if (userManager.wxName.isEmpty()) {
            var mobile = userManager.mobile
            if (mobile.isNotEmpty()) {
                mobile = mobile.substring(0, 3) + "****" + mobile.substring(mobile.length - 4, mobile.length)
            }
            title = "Hi,我是$mobile"
        } else {
            title = "Hi,我是" + userManager.wxName
        }
        val content = "送你一个赚钱的新模式，\r\n快点加入跟我一起赚钱吧"
        shareDialog.setShareAvatar(userManager.wxHeader)
        shareDialog.setShareTitle(title)
        shareDialog.setShareContent(content)
        shareDialog.show()
    }

    /**
     * 分享文章
     */
    private fun shareArticle(coin: Int) {
        val bundle = Bundle()
        bundle.putInt(Constant.WRAPPER_TYPE, Constant.WRAPPER_TYPE_WZ)
        readyGo(WrapperActivity::class.java, bundle)
    }

    /**
     * 高额任务提示弹框
     */
    private fun highVideoTint(taskBean: MyInfo.AutoListBean) {
        val ssb = SpanUtils()
                .append("1.点击开始任务，观看广告时，点击广告中的下载APP区域\r\n" +
                        "2.等待APP下载完成后，安装该APP\r\n" +
                        "3.通过好赚钱APP打开该APP并试玩至少30秒" +
                        "\n\n")
                .append("说明:有些可能不是下载APP类型的广告，请关闭广告后重试").setFontSize(BubbleUtils.dp2px(12))
                .create()

        DialogUtils.showDialog(mContext, "任务步骤", ssb, "取消", "开始任务", object : DialogListener() {
            override fun onClick(dialog: Dialog?, v: View?) {
                dialog?.dismiss()

                when (v?.id) {
                    R.id.dialog_btn_right -> {

                        carrierType = Constant.CARRIER_HIGH_ACTIVITY
                        videoAdingManager.setIsHighWeight(true)
                        awardVideo(taskBean.otherConfig.coin, Constant.CARRIER_HIGH_ACTIVITY)

                        // 注册高额任务广播监听
                        registerBroad()
                    }
                }
            }
        })
    }

    /**
     * 打开应用使用记录授权弹框
     */
    private fun openAppUsageStats() {
        DialogUtils.showDialog(mContext, "任务步骤", "该任务需要【应用使用记录】权限", "取消", "打开授权", object : DialogListener() {
            override fun onClick(dialog: Dialog?, v: View?) {
                dialog?.dismiss()

                when (v?.id) {
                    R.id.dialog_btn_right -> {
                        AppUtil.openUsageStats(mContext)
                    }
                }
            }
        })
    }

    /**
     * 注册高额任务监听
     */
    private fun registerBroad() {
        if (mReceiverBroadcastReceiver != null) return

        mContext.startService(Intent(context, AppInstallService::class.java))

        mReceiverBroadcastReceiver = object : BroadcastReceiver() {
            override fun onReceive(context: Context?, intent: Intent?) {
                if (intent == null) return

                try {
                    val pkg = intent.getStringExtra("pkg")

                    // 非高额任务不监听下载安装
                    if (TextUtils.equals(carrierType, Constant.CARRIER_HIGH_ACTIVITY)) {
                        mCurrentPkg = pkg
//                        ps.put(Constant.HIGH_TASK_PKG_NAME, pkg)

                        myPresenter.setHighTaskType(Constant.CARRIER_HIGH_ACTIVITY, "3")
                    } else if (TextUtils.equals(pkg, pkgMCRSName)) {
                        // 上报后台更新按钮状态
                        myPresenter.setHighTaskType(pkgMCRSCarrier, "1", pkgMCRSKey)
                    }

                } catch (e: Exception) {
                    e.printStackTrace()
                }

            }
        }

        val intentFilter = IntentFilter()
        intentFilter.addAction(AppInstallService.APP_INSTALL_ACTION)
        mContext.registerReceiver(this.mReceiverBroadcastReceiver, intentFilter)
    }

    /**
     * 坐标移动至每日任务
     */
    fun turnDayTask() {
        if (signCardBean != null) {
            scrollviewMy.scrollTo(0, llMyRoot.height -
                    recy_my.height -
                    item_customer_service.height -
                    item_bottom_qqGroupNum.height -
                    item_bottom_info.height -
                    viewTitleDayTask.height -
                    Utils.dip2px(context, 40f)
            )
            return
        }

        Timer().schedule(800) {
            activity?.runOnUiThread {
//                scrollviewMy.scrollTo(0, llMyRoot.height - viewTitleDayTask.height)
                scrollviewMy.scrollTo(0, llMyRoot.height -
                        recy_my.height -
                        item_customer_service.height -
                        item_bottom_qqGroupNum.height -
                        item_bottom_info.height -
                        viewTitleDayTask.height -
                        Utils.dip2px(context, 40f)
                )
            }
        }
    }

    /**
     * 下载安装广播回收
     */
    private fun onDestroyBroadcastReceiver() {
        if (mReceiverBroadcastReceiver != null) {
            mContext.stopService(Intent(context, AppInstallService::class.java))
            mContext.unregisterReceiver(mReceiverBroadcastReceiver)
            mReceiverBroadcastReceiver = null
        }
    }

    private fun gotoMoku() {
        RxPermissions(requireActivity())
                .request(Manifest.permission.READ_PHONE_STATE,
                        Manifest.permission.READ_EXTERNAL_STORAGE,
                        Manifest.permission.WRITE_EXTERNAL_STORAGE)
                .subscribe { granted: Boolean ->
                    if (granted) {
                        MokuManager.gotoMoku(requireContext())

                        if (ps.getBoolean(Constant.MOKU_FLAG_GUIDE, true)) {
                            readyGo(MokuGuideActivity::class.java)
                            ps.put(Constant.MOKU_FLAG_GUIDE, false)
                        }
                    } else {
                        showMissingPermissionDialog("设备,存储")
                    }
                }
    }

    /**
     *      Banner点击事件
     */
    override fun onPageClick(position: Int) {
        mBannerData?.let {
            // 广告不在最后banner展示时，需要position-1,否则加入穿山甲广告导致数据越界
            var serverBannerPosition = position
            if (it.list.size != it.position) {
                serverBannerPosition = position - 1
            }

            val pkg = it.list[serverBannerPosition].pkg
            if (!TextUtils.isEmpty(pkg) && AppUtil.checkPackInfo(requireActivity(), pkg)) {
                AppTryPlayManager.toTryPlay(pkg)
            } else {
                //未安装
                val bundle = Bundle()
                bundle.putString(WebActivity.WEB_TITLE, it.list[serverBannerPosition].title)
                bundle.putString(WebActivity.WEB_URL, it.list[serverBannerPosition].url)
                readyGo(WebActivity::class.java, bundle)
            }
        }
    }

}